/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.task.field;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import nl.cloudfarming.client.model.Entity;
import nl.cloudfarming.client.task.ExportAction;
import nl.cloudfarming.client.task.ExportableTaskCapability;
import nl.cloudfarming.client.task.Task;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
public class TaskExportButton extends javax.swing.JPanel implements LookupListener {

    private Task task;
    
    /**
     * Creates new form TaskExportButton
     */
    public TaskExportButton() {
        initComponents();
        exportButton.addActionListener(new ExportActionListener());
    }
    
    public TaskExportButton(Task task) {
        this();
        setTask(task);
    }
    
    public void setTask(Task task) {
        this.task = task;
        task.getLookup().lookupResult(Entity.class).addLookupListener(this);
        exportButton.setEnabled(task.isComplete());
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        exportButton = new javax.swing.JButton();

        exportButton.setText(org.openide.util.NbBundle.getMessage(TaskExportButton.class, "TaskExportButton.exportButton.text")); // NOI18N
        exportButton.setToolTipText(org.openide.util.NbBundle.getMessage(TaskExportButton.class, "TaskExportButton.exportButton.toolTipText")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(exportButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(exportButton)
                .addGap(0, 0, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton exportButton;
    // End of variables declaration//GEN-END:variables

    @Override
    public void resultChanged(LookupEvent ev) {
        exportButton.setEnabled(task.isComplete());
    }
    
    private class ExportActionListener implements ActionListener {

        @Override
        public void actionPerformed(ActionEvent e) {
            List<ExportableTaskCapability> exportableTasks = (List<ExportableTaskCapability>) task.getLookup().lookupAll(ExportableTaskCapability.class);
            ExportAction exportAction = new ExportAction(exportableTasks);
            exportAction.actionPerformed(null);
        }
        
    }
}
