/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.task.field;

import java.util.logging.Logger;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
//FIXME: move task and controller logic out of the panel and use the extracted panel (in task-core) directly
public class WorkWidthPanel extends nl.cloudfarming.client.task.WorkWidthPanel implements ChangeListener {

    //String values are used because an array of double values is not displayed
    //properly by the spinner. String values are used that are later converted
    //to double values
    private static final String MIN_WORK_WIDTH = Double.toString(FieldTask.MIN_WORK_WIDTH);
    private static final String[] DEFAULT_WORK_WIDTH_VALUES = {MIN_WORK_WIDTH, "10.0", "20.0", "25.0"};
    private static final Logger LOGGER = Logger.getLogger(WorkWidthPanel.class.getCanonicalName());

    private FieldTask task;

    /**
     * Creates new form WorkWidthPanel
     */
    public WorkWidthPanel() {
       super(DEFAULT_WORK_WIDTH_VALUES);
       getWorkWidthSpinner().addChangeListener(this);
    }

    public void setTask(FieldTask task) {
        this.task = task;
        setWorkWidthValue(task.getWorkWidth());
    }

    /**
     * When the value of the spinner changes, update the work width value of the
     * task contained by this panel.
     *
     * @param e event fired by the workWidthSpinner
     */
    @Override
    public void stateChanged(ChangeEvent e) {
        task.setWorkWidth(getWorkWidthValue());
    }

}
