/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.task.field.tree;

import nl.cloudfarming.client.task.tree.TaskRootNode;
import nl.cloudfarming.client.task.field.FieldTaskManager;
import org.netbeans.api.project.Project;
import org.netbeans.spi.project.ui.support.NodeFactory;
import org.netbeans.spi.project.ui.support.NodeFactorySupport;
import org.netbeans.spi.project.ui.support.NodeList;
import org.openide.loaders.DataFolder;
import org.openide.util.Lookup;

/**
 *
 * @author Maciek Dulkiewicz
 */
@NodeFactory.Registration(projectType = TaskRootNode.FOLDER_PATH)
public class FieldTaskCategoryNodeFactory implements NodeFactory {

    @Override
    public NodeList<?> createNodes(Project project) {
        FieldTaskManager manager = Lookup.getDefault().lookup(FieldTaskManager.class);
        DataFolder fieldTaskFolder = DataFolder.findFolder(manager.getStorageFolder(project));
        return NodeFactorySupport.fixedNodeList(new FieldTaskCategoryNode(fieldTaskFolder.getNodeDelegate(), project));
    }
}
